// C Source File
// Created 6/6/2004; 2:26:46 PM

#ifndef _ENEMY_C_
#define _ENEMY_C_

#include "enemy.h"

short checkEnemyCollision(Enemy *this, Point *location)
{
	int x0 = this->location.x - this->square/2,
		z0 = this->location.z - this->square/2,
		x1 = this->location.x + this->square/2,
		z1 = this->location.z + this->square/2,
		y0 = this->location.y - this->square/2,
		y1 = this->location.y + this->square/2;


	if (location->x >= x0 && location->x <= x1
	&&  location->z >= z0 && location->z <= z1
	&&  location->y >= y0 && location->y <= y1)
		return 1;

	return 0;
}

void moveEnemy(Enemy *this)
{
	this->location.x += this->momentum[this->current_interval].x;
	this->location.y += this->momentum[this->current_interval].y;
	this->location.z += this->momentum[this->current_interval].z;

	this->angle.x += this->spin[this->current_interval].x;
	this->angle.y += this->spin[this->current_interval].y;
	this->angle.z += this->spin[this->current_interval].z;

	this->current_time++;
	if (this->current_time > this->time_interval[this->current_interval]
	&&  this->current_interval < this->numintervals-1)
		this->current_interval++;
}

void createEnemyCopter(Enemy *this)
{
	this->angle = newAngle(0, 128, 0);
	this->spin[0] = newAngle(0, 0, 0);
	this->location = newPoint(0, 0, 0);
	this->momentum[0] = newPoint(0, 0, 0);
	this->numintervals = 1;
	this->time_interval[0] = 0;
	this->current_interval = 0;
	this->current_time = 0;
	this->fireRatio = 20;
	this->fireMomentum = newPoint(0, 0, -2);

	this->damage = 0;
	this->maxdamage = 15;
	this->square = 8;
	this->type = COPTER;
	this->weapon.energy = 0;

	this->numlines = 8;

	this->objlines[0].point[0] = newPoint( 0, -2,  0);
	this->objlines[0].point[1] = newPoint( 4,  2,  4);

	this->objlines[1].point[0] = newPoint( 0, -2,  0);
	this->objlines[1].point[1] = newPoint(-4,  2, -4);

	this->objlines[2].point[0] = newPoint( 0, -2,  0);
	this->objlines[2].point[1] = newPoint(-4,  2,  4);

	this->objlines[3].point[0] = newPoint( 0, -2,  0);
	this->objlines[3].point[1] = newPoint( 4,  2, -4);

	this->objlines[4].point[0] = newPoint(-4,  2,  4);
	this->objlines[4].point[1] = newPoint( 4,  2,  4);

	this->objlines[5].point[0] = newPoint(-4,  2,  4);
	this->objlines[5].point[1] = newPoint(-4,  2, -4);

	this->objlines[6].point[0] = newPoint( 4,  2, -4);
	this->objlines[6].point[1] = newPoint(-4,  2, -4);

	this->objlines[7].point[0] = newPoint( 4,  2, -4);
	this->objlines[7].point[1] = newPoint( 4,  2,  4);


}

void createEnemyFighter(Enemy *this)
{
	this->angle = newAngle(0, 128, 0);
	this->spin[0] = newAngle(0, 0, 0);
	this->location = newPoint(0, 0, 0);
	this->momentum[0] = newPoint(0, 0, 0);
	this->numintervals = 1;
	this->time_interval[0] = 0;
	this->current_interval = 0;
	this->current_time = 0;
	this->fireRatio = 0;
	this->fireMomentum = newPoint(0, 0, -3);

	this->damage = 0;
	this->maxdamage = 8;
	this->square = 8;
	this->type = FIGHTER;
	this->weapon.energy = 0;

	this->numlines = 5;

	this->objlines[0].point[0] = newPoint( 0,  2, -5);
	this->objlines[0].point[1] = newPoint( 0, -2,  1);

	this->objlines[1].point[0] = newPoint( 0,  2, -5);
	this->objlines[1].point[1] = newPoint(-5,  3,  5);

	this->objlines[2].point[0] = newPoint( 0,  2, -5);
	this->objlines[2].point[1] = newPoint( 5,  3,  5);

	this->objlines[3].point[0] = newPoint( 5,  3,  5);
	this->objlines[3].point[1] = newPoint( 0, -2,  1);

	this->objlines[4].point[0] = newPoint(-5,  3,  5);
	this->objlines[4].point[1] = newPoint( 0, -2,  1);

}

void createEnemyShieldGen(Enemy *this)
{
	this->angle = newAngle(0, 0, 0);
	this->spin[0] = newAngle(0, 0, 0);
	this->location = newPoint(0, 0, 0);
	this->momentum[0] = newPoint(0, 0, 0);
	this->time_interval[0] = 0;
	this->numintervals = 1;
	this->current_interval = 0;
	this->current_time = 0;
	this->fireRatio = 0;
	this->fireMomentum = newPoint(0, 0, -3);

	this->damage = 0;
	this->maxdamage = 5;
	this->square = 8;
	this->type = SHIELDGEN;
	this->weapon.energy = 0;

	this->numlines = 8;

	this->objlines[ 0].point[0] = newPoint( -4, -4,  4);
	this->objlines[ 0].point[1] = newPoint( -4, -4, -4);

	this->objlines[ 1].point[0] = newPoint( -4, -4, -4);
	this->objlines[ 1].point[1] = newPoint(  4, -4, -4);

	this->objlines[ 2].point[0] = newPoint(  4, -4, -4);
	this->objlines[ 2].point[1] = newPoint(  4, -4,  4);

	this->objlines[ 3].point[0] = newPoint(  4, -4,  4);
	this->objlines[ 3].point[1] = newPoint( -4, -4,  4);

	this->objlines[ 4].point[0] = newPoint( -4, -4,  4);
	this->objlines[ 4].point[1] = newPoint( -7, 15,  7);

	this->objlines[ 5].point[0] = newPoint( -4, -4, -4);
	this->objlines[ 5].point[1] = newPoint( -7, 15, -7);

	this->objlines[ 6].point[0] = newPoint(  4, -4, -4);
	this->objlines[ 6].point[1] = newPoint(  7, 15, -7);

	this->objlines[ 7].point[0] = newPoint(  4, -4,  4);
	this->objlines[ 7].point[1] = newPoint(  7, 15,  7);
}

void createEnemyGenerator(Enemy *this)
{
	this->angle = newAngle(0, 0, 0);
	this->spin[0] = newAngle(2, 2, 2);
	this->location = newPoint(0, 0, 0);
	this->momentum[0] = newPoint(0, 0, 0);
	this->time_interval[0] = 0;
	this->numintervals = 1;
	this->current_interval = 0;
	this->current_time = 0;
	this->fireRatio = 2;
	this->fireMomentum = newPoint(0, 0, -3);

	this->damage = 0;
	this->maxdamage = 100;
	this->square = 32;
	this->type = GENERATOR;
	this->weapon.energy = 0;

	this->numlines = 12;

	this->objlines[ 0].point[0] = newPoint( -16, -16,  16);
	this->objlines[ 0].point[1] = newPoint( -16, -16, -16);

	this->objlines[ 1].point[0] = newPoint( -16, -16, -16);
	this->objlines[ 1].point[1] = newPoint(  16, -16, -16);

	this->objlines[ 2].point[0] = newPoint(  16, -16, -16);
	this->objlines[ 2].point[1] = newPoint(  16, -16,  16);

	this->objlines[ 3].point[0] = newPoint(  16, -16,  16);
	this->objlines[ 3].point[1] = newPoint( -16, -16,  16);

	this->objlines[ 4].point[0] = newPoint( -16, -16,  16);
	this->objlines[ 4].point[1] = newPoint( -16,  16,  16);

	this->objlines[ 5].point[0] = newPoint( -16, -16, -16);
	this->objlines[ 5].point[1] = newPoint( -16,  16, -16);

	this->objlines[ 6].point[0] = newPoint(  16, -16, -16);
	this->objlines[ 6].point[1] = newPoint(  16,  16, -16);

	this->objlines[ 7].point[0] = newPoint(  16, -16,  16);
	this->objlines[ 7].point[1] = newPoint(  16,  16,  16);

	this->objlines[ 8].point[0] = newPoint( -16,  16,  16);
	this->objlines[ 8].point[1] = newPoint( -16,  16, -16);

	this->objlines[ 9].point[0] = newPoint( -16,  16, -16);
	this->objlines[ 9].point[1] = newPoint(  16,  16, -16);

	this->objlines[10].point[0] = newPoint(  16,  16, -16);
	this->objlines[10].point[1] = newPoint(  16,  16,  16);

	this->objlines[11].point[0] = newPoint(  16,  16,  16);
	this->objlines[11].point[1] = newPoint( -16,  16,  16);
}

#endif