// C Source File
// Created 6/5/2004; 5:50:33 PM

// Delete or comment out the items you do not need.
#define COMMENT_STRING         "Corrupted Memory"
#define COMMENT_PROGRAM_NAME   "corrupt"
#define COMMENT_VERSION_STRING "version major.minor.revision-subrevision alpha"
#define COMMENT_VERSION_NUMBER 0,4,0,0 /* major, minor, revision, subrevision */

#include <tigcclib.h>

#include "extgraph.h"
#include "gfx.h"
#include "ship.h"
#include "enemy.h"
#include "world.h"
#include "explosion.h"


short play(void *screen_buffer, short start_level, int *score);
void setupFloor(Line *this);
short doMenu(void *screen_buffer, short *level, int score);

// Main Function
void _main(void)
{
	ClrScr();

	INT_HANDLER save_int_1;

	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);   // redirect auto-int 1 to "nothing"

	if (USEGRAYSCALE) {
		if (!GrayOn()) {
			SetIntVec (AUTO_INT_1, save_int_1);
			return;
		}
	}

	if (GrayCheckRunning()) SetPlane(0);
		ClrScr();
	if (GrayCheckRunning()) SetPlane(1);
		ClrScr();

	void *screen;
	if (USEGRAYSCALE) {
		screen = malloc(GRAYDBUFFER_SIZE);
		if(screen == NULL) {
			SetIntVec (AUTO_INT_1, save_int_1);

			return;
		}

		GrayDBufInit(screen);
	}
	else {
		screen = malloc(LCD_SIZE);
		if (!screen) {
			SetIntVec (AUTO_INT_1, save_int_1);
			return;
		}
		PortSet (screen, 239, 127);
	}

	int high;

	FILE *fp = fopen("zcorrupt","rb");
	if (fp == NULL) {
		high = 0;
		fp = fopen("zcorrupt","wb");

		fputc (0, fp);
		fputc (0, fp);
		fputc (0, fp);

		fputc (0, fp);
		fputs ("pref", fp);
		fputc (0, fp);
		fputc (OTH_TAG, fp);
	}
	else {
		high  = fgetc(fp)*65536;
		high += fgetc(fp)*256;
		high += fgetc(fp);
	}
	fclose(fp);

	int tempscore = 0;
	int done = 0;
	short startlevel = 0;
	while (!done) {

		if (!doMenu(screen, &startlevel, high))
			done = 1;

		if (done == 1)
			break;

		int won = play(screen, startlevel, &tempscore);

		if (tempscore > high)
			high = tempscore;

		if (USEGRAYSCALE) {
			GrayDBufSetHiddenAMSPlane(0);
			ClrScr();
			GrayDBufSetHiddenAMSPlane(1);
		}
		ClrScr();

		FontSetSys(F_6x8);

		if (won == 1) {
			DrawStr(0, 0, "Congratulations!", A_NORMAL);
			DrawStr(0, 8, "You have done nothing!", A_NORMAL);
		}

		if (won == 0) {
			DrawStr(0, 0, "Woah is everything.", A_NORMAL);
			DrawStr(0, 8, "Nothing has happened.", A_NORMAL);
		}

		if (USEGRAYSCALE)
			GrayDBufToggleSync();
		else
			LCD_restore(screen);

		if (won != -1)
			while (!_keytest(RR_ENTER));
	}

	fp = fopen("zcorrupt","wb");

	fputc (high/65536, fp);
	high = high%65536;
	fputc (high/256, fp);
	high = high%256;
	fputc (high, fp);

	fputc (0, fp);
	fputs ("pref", fp);
	fputc (0, fp);
	fputc (OTH_TAG, fp);
	fclose (fp);

	if (USEGRAYSCALE)
		GrayDBufToggleSync();
	else
		LCD_restore(screen);

	if (GrayCheckRunning()) GrayOff();

	if (!USEGRAYSCALE) {
		PortRestore();
	}

	free(screen);


	SetIntVec (AUTO_INT_1, save_int_1);



}

short play(void *screen_buffer, short start_level, int *score)
{
	short exit = 0;

	int currentWorld;

	int won;

	int currentScore = 0;

	for (currentWorld=start_level; currentWorld<NUMLEVELS; currentWorld++)
	{
		ClrScr();

		printf_xy(0,  0, "World %d", currentWorld);
		printf_xy(0, 10, "Press ENTER");

		if (USEGRAYSCALE)
			GrayDBufToggleSync();
		else
			LCD_restore(screen_buffer);

		while (!_keytest(RR_ENTER));

		Camera myCamera;
		myCamera.distortion = 100;
		myCamera.center = newPoint(0, -80, -30);
		myCamera.angle = newAngle(-40, 128, 0);

		Point floorLocation = newPoint(0, 0, 50);
		Line floorLines[3];
		setupFloor(floorLines);

		Line shipLines[SHIP_A_LINEMAX];
		Ship myShip;
		myShip.objlines = shipLines;
		createShipA(&myShip);
		myShip.location.y = -15;
		myShip.score = currentScore;

		Line shieldLines[8];
		Enemy shieldGenTurret;
		shieldGenTurret.objlines = shieldLines;
		 createEnemyShieldGen(&shieldGenTurret);
		Line genLines[12];
		Enemy generator;
		generator.objlines = genLines;
		 createEnemyGenerator(&generator);
		Line fighterLines[5];
		Enemy fighter;
		fighter.objlines = fighterLines;
		 createEnemyFighter(&fighter);
		Line copterLines[8];
		Enemy copter;
		copter.objlines = copterLines;
		 createEnemyCopter(&copter);

		World myWorld;
		createWorld(&myWorld, currentWorld);

		int currentGroup = 0;
		Group myGroup;
		setupGroup(&myGroup, currentWorld, currentGroup, &generator, &shieldGenTurret, &fighter, &copter);

		Weapon defaultPulse;
		Line pulseLines[4];
		defaultPulse.objlines = pulseLines;
		 createPulse(&defaultPulse);
		Weapon defaultLaser;
		Line laserLines[2];
		defaultLaser.objlines = laserLines;
		 createLaser(&defaultLaser);
		Weapon defaultBlast;
		Line blastLines[3];
		defaultBlast.objlines = blastLines;
		 createBlast(&defaultBlast);
		Weapon defaultBarrier;
		Line barrierLines[2];
		defaultBarrier.objlines = barrierLines;
		 createSheildBarrier(&defaultBarrier);

		Explosion explosion;
		explosion.time = 0;

		unsigned char x_roll=0, z_roll=0, y_roll=0;

		int groupZ = 0, i, e;

		OSFreeTimer(USER_TIMER);
		OSRegisterTimer(USER_TIMER, 4);

		OSFreeTimer(MISC_TIMER);
		OSRegisterTimer(MISC_TIMER, 2);

		won = -1;
		int collide, jump=64, fast;

		FontSetSys(F_4x6);

		while (!exit && (won==-1 || explosion.time > 0))
		{
			if (USEGRAYSCALE) {
				GrayDBufSetHiddenAMSPlane(0);
				ClrScr();
				GrayDBufSetHiddenAMSPlane(1);
			}
			ClrScr();

			//myCamera.center.x = myShip.location.x;
			
			if (won==-1 
				&& (currentGroup < myWorld.numgroups-1
				||  myGroup.enemy[0].damage < myGroup.enemy[0].maxdamage))
				myCamera.center.z = myShip.location.z - 20;
			else if (currentGroup == myWorld.numgroups-1
				 &&  myGroup.enemy[0].damage >= myGroup.enemy[0].maxdamage) {
				myShip.location.z+=2;//speed things up a bit
				myCamera.center.z = myShip.location.z - 20;
				myCamera.center.x++;
				myCamera.angle.y--;
			}
			else
			{
				myCamera.center.x+=2;
				myCamera.center.z+=1;
				myCamera.center.y+=2;
				myCamera.angle.y-=2;
			}


			if (jump > 0) {
				jump--;
				z_roll = (32-jump)*8;

				if (jump > 16)
					myShip.location.y = -15 - (32-jump);
				else
					myShip.location.y = -15 - jump;
			}
			else {
				myShip.location.y = -15;
			}


			if (myShip.shield >= 0)
				drawLines(&myCamera, myShip.location, newAngle(x_roll, y_roll, z_roll), myShip.objlines, myShip.numlines, 2);


			collide = doGroupStuff(&myCamera, &myGroup, &myShip, &defaultPulse, &defaultBarrier);
			if (collide > -1) {
				makeFloorExplosion(&explosion, 8);
				explosion.location = myGroup.enemy[collide].location;
				explosion.location.y = 0;
				myGroup.enemy[collide].damage = myGroup.enemy[collide].maxdamage+1;
				myShip.score += myGroup.enemy[collide].type*10;
				myShip.shield -= 51;
			}

			if (myShip.shield < 0)
				won = 0;

			if (explosion.time > 0)
				doExplosionStuff(&myCamera, &explosion);

			for (i=0; i<myShip.numweapons; i++)
			{
				doWeaponStuff(&myCamera, &myShip.weapons[i], newPoint(0, 0, 0));

				for (e=0; e<myGroup.numenemies; e++) {
					if (myGroup.enemy[e].damage < myGroup.enemy[e].maxdamage
					&&	checkEnemyCollision(&myGroup.enemy[e], &myShip.weapons[i].location)) {
						myShip.weapons[i].energy = 0;
						myGroup.enemy[e].damage += myShip.weapons[i].damage;
						if (myGroup.enemy[e].damage >= myGroup.enemy[e].maxdamage) {
							explosion.location = myGroup.enemy[e].location;
							if (myGroup.enemy[e].type == SHIELDGEN || myGroup.enemy[e].type == GENERATOR)
								makeFloorExplosion(&explosion, myGroup.enemy[e].square);
							else
								makeCircleExplosion(&explosion, 4);
							myShip.score += myGroup.enemy[e].type*10;
						}
					}
				}

				if (myShip.weapons[i].energy <= 0)
					deleteWeapon(&myShip, i);
			}

			z_roll=0;
			x_roll=0;
			fast=0;

			drawLines(&myCamera, floorLocation, newAngle(0, 0, 0), floorLines, 3, 0);

			if (GrayCheckRunning()) GrayDBufSetHiddenAMSPlane(LIGHT_PLANE);

			printf_xy(LCD_WIDTH/2, 0, "%d", myShip.score+currentScore);
			printf_xy(0,  0, "shield:   %d%%", myShip.shield);
			printf_xy(0,  8, "energy: %d%%", myShip.energy);

			if (USEGRAYSCALE)
				GrayDBufToggleSync();
			else
				LCD_restore(screen_buffer);

			myShip.energy += myShip.chargeRate;
			if (myShip.energy > 100)
				myShip.energy = 100;

			if (_keytest(RR_CLEAR))
				exit = 1;

			if (_keytest(RR_LEFT) && myShip.location.x > -50) {
				z_roll = -7;
				myShip.location.x -= 4;
			}
			if (_keytest(RR_RIGHT) && myShip.location.x < 50) {
				z_roll = 7;
				myShip.location.x += 4;
			}

			if (_keytest(RR_UP)) {
				x_roll = 8;
				fast = 1;
			}

			if (_keytest(RR_F1) && myShip.energy > 2 && myShip.shield < 100) {
				myShip.energy -= 2;
				myShip.shield += 1;
			}

			if (_keytest(RR_F2) && myShip.shield > 5 && myShip.energy < 96) {
				myShip.energy += 5;
				myShip.shield -= 5;
			}

			if (_keytest(RR_SHIFT) && jump == 0) {
				jump = 32;
			}

			if (_keytest(RR_2ND) && myShip.energy > 30  && jump == 0) {
				registerWeapon(&myShip, &defaultLaser);
				myShip.energy -= 20;
				OSTimerRestart(MISC_TIMER);
			}

			if (_keytest(RR_DIAMOND) && myShip.energy >= 100 && jump == 0) {
				registerWeapon(&myShip, &defaultBlast);
				myShip.energy -= 100;
				OSTimerRestart(MISC_TIMER);
			}

			if (OSTimerExpired(USER_TIMER)
			&& (	currentGroup < myWorld.numgroups-1
				|| 	myShip.location.z < myGroup.length+groupZ-150
				||  myGroup.enemy[0].damage >= myGroup.enemy[0].maxdamage)) {
				myShip.location.z += 2 + fast*2;
				OSTimerRestart(USER_TIMER);

				floorLocation.z = myShip.location.z-myShip.location.z%50+50;

				if (myShip.location.z > myGroup.length + groupZ) {
					groupZ += myGroup.length;
					currentGroup++;

					setupGroup(&myGroup, currentWorld, currentGroup, &generator, &shieldGenTurret, &fighter, &copter);

					if (currentGroup >= myWorld.numgroups)
						won = 1;
				}
			}

			if (myShip.shield < 0)
				won = 0;


	/*
			if (_keytest(RR_DOWN)) {
				x_roll = -7;
				myShip.location.y--;
			}
			if (_keytest(RR_UP)) {
				x_roll = 7;
				myShip.location.y++;
			}*/


		}

		currentScore += myShip.score;

		if (won != 1)
			break;

	}

	*score = currentScore;

	return won;

}

void setupFloor(Line *this)
{
	this[0].point[0] = newPoint(-50, 0, 0);
	this[0].point[1] = newPoint( 50, 0, 0);

	this[1].point[0] = newPoint(-50, 0, -50);
	this[1].point[1] = newPoint( 50, 0, -50);

	this[2].point[0] = newPoint(-50, 0, -100);
	this[2].point[1] = newPoint( 50, 0, -100);

}

short doMenu(void *screen_buffer, short *level, int score)
{
	if (USEGRAYSCALE) {
		GrayDBufSetHiddenAMSPlane(0);
		ClrScr();
		GrayDBufSetHiddenAMSPlane(1);
	}
	ClrScr();

	Camera myCamera;
	myCamera.distortion = 170;
	myCamera.center = newPoint(-20, -70, -35);
	myCamera.angle = newAngle(-40, 128, 0);

	Line shipLines[SHIP_A_LINEMAX];
	Ship testShip;
	testShip.objlines = shipLines;
	createShipA(&testShip);


	int done=0;

	unsigned char a = 0;

	while (!done)
	{
		ClrScr();

		FontSetSys(F_6x8);

		DrawStr(0, 0, "Corrupted Memory v0.3.0-2", A_NORMAL);
		DrawLine(0, 9, LCD_WIDTH-1, 9, A_NORMAL);
		DrawStr(0, 11, "paulygon software", A_NORMAL);
		DrawLine(0, 20, LCD_WIDTH-1, 20, A_NORMAL);
		DrawLine(0, 22, LCD_WIDTH-1, 22, A_NORMAL);

		DrawStr(0, 40, "2nd:  Start Game", A_NORMAL);
		printf_xy(0, 50, "<->:  Start Level: %d", *level);
		DrawStr(0, 90, "ESC:  Exit", A_NORMAL);

		FontSetSys(F_4x6);

		printf_xy(0, 24, "High Score: %d", score);

		drawLines(&myCamera, testShip.location, newAngle(0, a+=2, 0), testShip.objlines, testShip.numlines, 2);

		if (USEGRAYSCALE)
			GrayDBufToggleSync();
		else
			LCD_restore(screen_buffer);

		if (_keytest(RR_2ND))
			return 1;
		if (_keytest(RR_ESC))
			return 0;

		if (_keytest(RR_LEFT))
			*level = *level - 1;
		if (*level < 0)
			*level = NUMLEVELS-1;

		if (_keytest(RR_RIGHT))
			*level = *level + 1;
		if (*level >= NUMLEVELS)
			*level = 0;

	}

	return 0;
}