// C Source File
// Created 6/6/2004; 2:32:29 PM

#include "world.h"

void setupGroup(Group *this, short world, short group, Enemy *defaultGenerator, Enemy *defaultShieldGen, Enemy *defaultFighter, Enemy *defaultCopter)
{
	switch (world)
	{
		case 0:
			getGroupSetup_world0(this, group, defaultGenerator, defaultShieldGen, defaultFighter);
		break;

		case 1:
			getGroupSetup_world1(this, group, defaultGenerator, defaultShieldGen, defaultFighter);
		break;

		case 2:
			getGroupSetup_world2(this, group, defaultGenerator, defaultShieldGen, defaultFighter, defaultCopter);
		break;
	}
}

void getGroupSetup_world2(Group *this, short group, Enemy *defaultGenerator, Enemy *defaultShieldGen, Enemy *defaultFighter, Enemy *defaultCopter)
{
	int i;

	switch(group) {
		case 0:
			this->numenemies = 10;
			this->length = 325;

			for (i=0; i<6; i++) {

				this->enemy[i] = *defaultCopter;
				this->enemy[i].angle = newAngle(0, 128, 0);
				this->enemy[i].location = newPoint(random(10)*10-45, 0, 200+i*20);
				this->enemy[i].numintervals = 3;
				this->enemy[i].time_interval[0] = 30;
				this->enemy[i].momentum[0] = newPoint(0, 0, 0);
				this->enemy[i].spin[0] = newAngle(0, 0, 0);
				this->enemy[i].time_interval[1] = 46;
				this->enemy[i].momentum[1] = newPoint(0, -1, 0);
				this->enemy[i].spin[1] = newAngle(-4, 0, 0);
				this->enemy[i].time_interval[2] = 0;
				this->enemy[i].momentum[2] = newPoint(0, 0, -2);
				this->enemy[i].spin[2] = newAngle(0, 0, 0);
				this->enemy[i].fireRatio = 10;

			}

			this->enemy[6] = *defaultShieldGen;
			this->enemy[6].location = newPoint(-45, -15, 325);
			this->enemy[6].fireRatio = 2;
			this->enemy[6].maxdamage = 20;
			this->enemy[6].type = BARRIER;
			this->enemy[6].fireMomentum = newPoint(10, 0, 0);

			this->enemy[7] = *defaultShieldGen;
			this->enemy[7].location = newPoint(45, -15, 325);
			this->enemy[7].fireRatio = 2;
			this->enemy[7].maxdamage = 20;
			this->enemy[7].type = BARRIER;
			this->enemy[7].fireMomentum = newPoint(-10, 0, 0);

			this->enemy[8] = *defaultShieldGen;
			this->enemy[8].location = newPoint(-60, -15, 325);
			this->enemy[8].fireRatio = 2;
			this->enemy[8].maxdamage = 20;
			this->enemy[8].type = BARRIER;
			this->enemy[8].fireMomentum = newPoint(15, 0, 0);

			this->enemy[9] = *defaultShieldGen;
			this->enemy[9].location = newPoint(60, -15, 325);
			this->enemy[9].fireRatio = 2;
			this->enemy[9].maxdamage = 20;
			this->enemy[9].type = BARRIER;
			this->enemy[9].fireMomentum = newPoint(-15, 0, 0);

		break;

		case 1:

			this->numenemies = 12;
			this->length = 200;

			for (i=0; i<7; i++) {
				this->enemy[i] = *defaultFighter;
				this->enemy[i].location = newPoint(i*10-30, -15, abs(i-4)*10+450);
				this->enemy[i].momentum[0] = newPoint(0, 0, -1);
				this->enemy[i].numintervals = 1;
			}

			this->enemy[7] = *defaultShieldGen;
			this->enemy[7].location = newPoint(-40, -15, 475);
			this->enemy[7].fireRatio = 2;
			this->enemy[7].fireMomentum = newPoint(1, 0, -2);

			this->enemy[8] = *defaultShieldGen;
			this->enemy[8].location = newPoint(40, -15, 475);
			this->enemy[8].fireRatio = 2;
			this->enemy[8].fireMomentum = newPoint(-1, 0, -2);

			this->enemy[9] = *defaultShieldGen;
			this->enemy[9].location = newPoint(0, -15, 520);
			this->enemy[9].fireRatio = 2;
			this->enemy[9].maxdamage = 30;
			this->enemy[9].fireMomentum = newPoint(0, 0, -4);

			this->enemy[10] = *defaultShieldGen;
			this->enemy[10].location = newPoint(0, -15, 520);
			this->enemy[10].fireRatio = 2;
			this->enemy[10].maxdamage = 30;
			this->enemy[10].fireMomentum = newPoint(-2, 0, -2);

			this->enemy[11] = *defaultShieldGen;
			this->enemy[11].location = newPoint(0, -15, 520);
			this->enemy[11].fireRatio = 2;
			this->enemy[11].maxdamage = 30;
			this->enemy[11].fireMomentum = newPoint(2, 0, -2);


		break;

		case 2:
			this->numenemies = 10;
			this->length = 250;

			for (i=0; i<4; i++) {
				this->enemy[i] = *defaultCopter;
				this->enemy[i].location = newPoint(i*20-30, 0, 525);
				this->enemy[i].angle = newAngle(0, 128, 0);
				this->enemy[i].numintervals = 3;
				this->enemy[i].time_interval[0] = 50;
				this->enemy[i].momentum[0] = newPoint(0, 0, 2);
				this->enemy[i].spin[0] = newAngle(0, 0, 0);
				this->enemy[i].time_interval[1] = 66;
				this->enemy[i].momentum[1] = newPoint(0, -1, 1);
				this->enemy[i].spin[1] = newAngle(-4, 0, 0);
				this->enemy[i].time_interval[2] = 0;
				this->enemy[i].momentum[2] = newPoint(0, 0, -2);
				this->enemy[i].spin[2] = newAngle(0, 0, 0);
				this->enemy[i].fireRatio = 15;
			}

			this->enemy[4] = *defaultShieldGen;
			this->enemy[4].location = newPoint(-40, -15, 650);
			this->enemy[4].fireRatio = 2;
			this->enemy[4].maxdamage = 20;
			this->enemy[4].fireMomentum = newPoint(2, 0, -5);

			this->enemy[5] = *defaultShieldGen;
			this->enemy[5].location = newPoint(40, -15, 650);
			this->enemy[5].fireRatio = 2;
			this->enemy[5].maxdamage = 20;
			this->enemy[5].fireMomentum = newPoint(-2, 0, -5);

			this->enemy[6] = *defaultShieldGen;
			this->enemy[6].location = newPoint(-40, -15, 700);
			this->enemy[6].fireRatio = 0;
			this->enemy[6].maxdamage = 100;
			this->enemy[6].fireMomentum = newPoint(0, 0, 0);
			this->enemy[6].numintervals = 3;
			this->enemy[6].time_interval[0] = 60;
			this->enemy[6].momentum[0] = newPoint(0, 0, 0);
			this->enemy[6].time_interval[1] = 80;
			this->enemy[6].momentum[1] = newPoint(3, 0, 0);
			this->enemy[6].spin[1] = newAngle (0, 1, 0);
			this->enemy[6].time_interval[2] = 0;
			this->enemy[6].momentum[2] = newPoint(0, 0, -4);
			this->enemy[6].spin[2] = newAngle(0, 0, 0);

			this->enemy[7] = *defaultShieldGen;
			this->enemy[7].location = newPoint(50, -15, 725);
			this->enemy[7].fireRatio = 0;
			this->enemy[7].maxdamage = 100;
			this->enemy[7].fireMomentum = newPoint(0, 0, 0);
			this->enemy[7].numintervals = 3;
			this->enemy[7].time_interval[0] = 60;
			this->enemy[7].momentum[0] = newPoint(0, 0, 0);
			this->enemy[7].time_interval[1] = 80;
			this->enemy[7].momentum[1] = newPoint(-3, 0, 0);
			this->enemy[7].spin[1] = newAngle(0, 1, 0);
			this->enemy[7].time_interval[2] = 0;
			this->enemy[7].momentum[2] = newPoint(0, 0, -4);
			this->enemy[7].spin[2] = newAngle(0, 0, 0);

			this->enemy[8] = *defaultShieldGen;
			this->enemy[8].location = newPoint(-50, -15, 750);
			this->enemy[8].fireRatio = 0;
			this->enemy[8].maxdamage = 100;
			this->enemy[8].fireMomentum = newPoint(0, 0, 0);
			this->enemy[8].numintervals = 3;
			this->enemy[8].time_interval[0] = 60;
			this->enemy[8].momentum[0] = newPoint(0, 0, 0);
			this->enemy[8].time_interval[1] = 80;
			this->enemy[8].momentum[1] = newPoint(3, 0, 0);
			this->enemy[8].spin[1] = newAngle(0, 1, 0);
			this->enemy[8].time_interval[2] = 0;
			this->enemy[8].momentum[2] = newPoint(0, 0, -4);
			this->enemy[8].spin[2] = newAngle(0, 0, 0);

			this->enemy[9] = *defaultShieldGen;
			this->enemy[9].location = newPoint(20, -15, 775);
			this->enemy[9].fireRatio = 0;
			this->enemy[9].maxdamage = 100;
			this->enemy[9].fireMomentum = newPoint(0, 0, 0);
			this->enemy[9].numintervals = 3;
			this->enemy[9].time_interval[0] = 60;
			this->enemy[9].momentum[0] = newPoint(0, 0, 0);
			this->enemy[9].time_interval[1] = 80;
			this->enemy[9].momentum[1] = newPoint(-2, 0, 0);
			this->enemy[9].spin[1] = newAngle(0, 1, 0);
			this->enemy[9].time_interval[2] = 0;
			this->enemy[9].momentum[2] = newPoint(0, 0, -4);
			this->enemy[9].spin[2] = newAngle(0, 0, 0);

		break;

		case 3:
			this->numenemies = 20;
			this->length = 250;

			for (i=0; i<20; i++) {

				this->enemy[i] = *defaultFighter;
				this->enemy[i].location = newPoint(random(9)*10-40, -15, 850+i*10);
				this->enemy[i].angle = newAngle(0, 128, 0);
				this->enemy[i].fireRatio = 0;
				this->enemy[i].maxdamage = 10;
				this->enemy[i].numintervals = 1;
				this->enemy[i].momentum[0] = newPoint(0, 0, -5);

			}

		break;

		case 4:
			this->numenemies = 6;
			this->length = 150;

			this->enemy[0] = *defaultShieldGen;
			this->enemy[0].location = newPoint(-35, -15, 1175);
			this->enemy[0].fireRatio = 2;
			this->enemy[0].maxdamage = 50;
			this->enemy[0].type = BARRIER;
			this->enemy[0].fireMomentum = newPoint(10, 0, 0);

			this->enemy[1] = *defaultShieldGen;
			this->enemy[1].location = newPoint(35, -15, 1175);
			this->enemy[1].fireRatio = 2;
			this->enemy[1].maxdamage = 50;
			this->enemy[1].type = BARRIER;
			this->enemy[1].fireMomentum = newPoint(-10, 0, 0);

			this->enemy[2] = *defaultShieldGen;
			this->enemy[2].location = newPoint(-50, -15, 1175);
			this->enemy[2].fireRatio = 2;
			this->enemy[2].maxdamage = 50;
			this->enemy[2].type = BARRIER;
			this->enemy[2].fireMomentum = newPoint(15, 0, 0);

			this->enemy[3] = *defaultShieldGen;
			this->enemy[3].location = newPoint(50, -15, 1175);
			this->enemy[3].fireRatio = 2;
			this->enemy[3].maxdamage = 50;
			this->enemy[3].type = BARRIER;
			this->enemy[3].fireMomentum = newPoint(-15, 0, 0);

			this->enemy[4] = *defaultFighter;
			this->enemy[4].location = newPoint(-40, -15, 1025);
			this->enemy[4].angle = newAngle(0, -22, 0);
			this->enemy[4].numintervals = 1;
			this->enemy[4].momentum[0] = newPoint(1, 0, 2);

			this->enemy[5] = *defaultFighter;
			this->enemy[5].location = newPoint(40, -15, 1025);
			this->enemy[5].angle = newAngle(0, 22, 0);
			this->enemy[5].numintervals = 1;
			this->enemy[5].momentum[0] = newPoint(-1, 0, 2);


			break;

		case 5:
			this->numenemies = 5;
			this->length = 300;

			this->enemy[0] = *defaultGenerator;
			this->enemy[0].location = newPoint(0, -6, 1400);
			this->enemy[0].fireRatio = 2;

			this->enemy[1] = *defaultShieldGen;
			this->enemy[1].location = newPoint(-10, -15, 1360);
			this->enemy[1].fireRatio = 5;
			this->enemy[1].spin[0] = newAngle(0, 2, 0);
			this->enemy[1].maxdamage = 10;

			this->enemy[2] = *defaultShieldGen;
			this->enemy[2].location = newPoint( 10, -15, 1360);
			this->enemy[2].fireRatio = 5;
			this->enemy[2].spin[0] = newAngle(0, 2, 0);
			this->enemy[2].maxdamage = 10;

			this->enemy[3] = *defaultShieldGen;
			this->enemy[3].location = newPoint(-20, -15, 1430);
			this->enemy[3].fireRatio = 5;
			this->enemy[3].spin[0] = newAngle(0, 2, 0);
			this->enemy[3].maxdamage = 20;

			this->enemy[4] = *defaultShieldGen;
			this->enemy[4].location = newPoint( 20, -15, 1430);
			this->enemy[4].fireRatio = 5;
			this->enemy[4].spin[0] = newAngle(0, 2, 0);
			this->enemy[4].maxdamage = 20;


		break;
	}
}

void getGroupSetup_world1(Group *this, short group, Enemy *defaultGenerator, Enemy *defaultShieldGen, Enemy *defaultFighter)
{
	int i;
	switch(group) {

		case 0:
			this->numenemies = 20;
			this->length = 500;

			for (i=0; i<5; i++)
			{
				this->enemy[i*2] = *defaultFighter;
				this->enemy[i*2].location = newPoint(-40, -15, i*20+150);
				this->enemy[i*2].numintervals = 3;
				this->enemy[i*2].time_interval[0] = 40;
				this->enemy[i*2].momentum[0] = newPoint(0, 0, -1);
				this->enemy[i*2].spin[0] = newAngle(0, 0, 0);
				this->enemy[i*2].time_interval[1] = 85;
				this->enemy[i*2].momentum[1] = newPoint(1, 0, 3);
				this->enemy[i*2].spin[1] = newAngle(0, 0, 0);
				this->enemy[i*2].time_interval[2] = 0;
				this->enemy[i*2].momentum[2] = newPoint(0, 0, -1);
				this->enemy[i*2].spin[2] = newAngle(0, 0, 0);
				this->enemy[i*2].fireRatio = 10;

				this->enemy[i*2+1] = *defaultFighter;
				this->enemy[i*2+1].location = newPoint(40, -15, i*20+150);
				this->enemy[i*2+1].numintervals = 3;
				this->enemy[i*2+1].time_interval[0] = 40;
				this->enemy[i*2+1].momentum[0] = newPoint(0, 0, -1);
				this->enemy[i*2+1].spin[0] = newAngle(0, 0, 0);
				this->enemy[i*2+1].time_interval[1] = 85;
				this->enemy[i*2+1].momentum[1] = newPoint(-1, 0, 3);
				this->enemy[i*2+1].spin[1] = newAngle(0, 0, 0);
				this->enemy[i*2+1].time_interval[2] = 0;
				this->enemy[i*2+1].momentum[2] = newPoint(0, 0, -1);
				this->enemy[i*2+1].spin[2] = newAngle(0, 0, 0);
				this->enemy[i*2+1].fireRatio = 10;
			}

			for (i=0; i<5; i++) {
				this->enemy[i*2+10] = *defaultShieldGen;
				this->enemy[i*2+10].location = newPoint(-40, -15, 350+i*30);
				this->enemy[i*2+10].fireRatio = 2;
				this->enemy[i*2+10].fireMomentum = newPoint(3, 0, -1);

				this->enemy[i*2+11] = *defaultShieldGen;
				this->enemy[i*2+11].location = newPoint(40, -15, 350+i*30);
				this->enemy[i*2+11].fireRatio = 2;
				this->enemy[i*2+11].fireMomentum = newPoint(-3, 0, -1);
			}

		break;

		case 1:

			this->numenemies = 20;
			this->length = 350;

			for (i=0; i<5; i++)
			{
				this->enemy[i] = *defaultFighter;
				this->enemy[i].location = newPoint(40+i*20, -15, 620);
				this->enemy[i].angle = newAngle(0, 64, 0);
				this->enemy[i].numintervals = 3;

				this->enemy[i].time_interval[0] = 40;
				this->enemy[i].momentum[0] = newPoint(-2, 0, -1);
				this->enemy[i].spin[0] = newAngle(0, 0, 0);

				this->enemy[i].time_interval[1] = 46;
				this->enemy[i].momentum[1] = newPoint(0, 0, 0);
				this->enemy[i].spin[1] = newAngle(0, 16, 0);

				this->enemy[i].time_interval[2] = 0;
				this->enemy[i].momentum[2] = newPoint(3, 0, -3);
				this->enemy[i].spin[2] = newAngle(0, 0, 0);

				this->enemy[i].fireRatio = 0;


				this->enemy[i+5] = *defaultFighter;
				this->enemy[i+5].location = newPoint(-40-i*20, -15, 640);
				this->enemy[i+5].angle = newAngle(0, -64, 0);
				this->enemy[i+5].numintervals = 3;

				this->enemy[i+5].time_interval[0] = 40;
				this->enemy[i+5].momentum[0] = newPoint(2, 0, -1);
				this->enemy[i+5].spin[0] = newAngle(0, 0, 0);

				this->enemy[i+5].time_interval[1] = 46;
				this->enemy[i+5].momentum[1] = newPoint(0, 0, 0);
				this->enemy[i+5].spin[1] = newAngle(0, -16, 0);

				this->enemy[i+5].time_interval[2] = 0;
				this->enemy[i+5].momentum[2] = newPoint(-3, 0, -3);
				this->enemy[i+5].spin[2] = newAngle(0, 0, 0);

				this->enemy[i+5].fireRatio = 0;
			}


			this->enemy[10] = *defaultShieldGen;
			this->enemy[10].location = newPoint(20, -15, 750);
			this->enemy[10].maxdamage = 20;
			this->enemy[10].fireRatio = 40;

			this->enemy[11] = *defaultShieldGen;
			this->enemy[11].location = newPoint(-30, -15, 760);
			this->enemy[11].maxdamage = 20;
			this->enemy[11].fireRatio = 40;

			this->enemy[12] = *defaultShieldGen;
			this->enemy[12].location = newPoint(-10, -15, 780);
			this->enemy[12].maxdamage = 20;
			this->enemy[12].fireRatio = 40;

			this->enemy[13] = *defaultShieldGen;
			this->enemy[13].location = newPoint(40, -15, 790);
			this->enemy[13].maxdamage = 20;
			this->enemy[13].fireRatio = 40;

			this->enemy[14] = *defaultShieldGen;
			this->enemy[14].location = newPoint(-50, -15, 800);
			this->enemy[14].maxdamage = 20;
			this->enemy[14].fireRatio = 40;

			this->enemy[15] = *defaultShieldGen;
			this->enemy[15].location = newPoint(-20, -15, 810);
			this->enemy[15].maxdamage = 20;
			this->enemy[15].fireRatio = 40;

			this->enemy[16] = *defaultShieldGen;
			this->enemy[16].location = newPoint(-40, -15, 820);
			this->enemy[16].maxdamage = 20;
			this->enemy[16].fireRatio = 40;

			this->enemy[17] = *defaultShieldGen;
			this->enemy[17].location = newPoint(10, -15, 830);
			this->enemy[17].maxdamage = 20;
			this->enemy[17].fireRatio = 40;

			this->enemy[18] = *defaultShieldGen;
			this->enemy[18].location = newPoint(30, -15, 840);
			this->enemy[18].maxdamage = 20;
			this->enemy[18].fireRatio = 40;

			this->enemy[19] = *defaultShieldGen;
			this->enemy[19].location = newPoint(0, -15, 850);
			this->enemy[19].maxdamage = 20;
			this->enemy[19].fireRatio = 40;

		break;

		case 2:
			this->numenemies = 15;
			this->length = 250;

			for (i=0; i<5; i++)
			{
				this->enemy[i] = *defaultFighter;
				this->enemy[i].location = newPoint(-40+i*20, -15, 950);
				this->enemy[i].angle = newAngle(0, 128, 0);
				this->enemy[i].numintervals = 3;

				this->enemy[i].time_interval[0] = 80;
				this->enemy[i].momentum[0] = newPoint(0, 0, 0);
				this->enemy[i].spin[0] = newAngle(0, 0, 0);

				this->enemy[i].time_interval[1] = 115;
				this->enemy[i].momentum[1] = newPoint(0, 0, 4);
				this->enemy[i].spin[1] = newAngle(0, 0, 0);

				this->enemy[i].time_interval[2] = 0;
				this->enemy[i].momentum[2] = newPoint(-((i-2)*2), 0, -4);
				this->enemy[i].spin[2] = newAngle(0, 0, 0);

				this->enemy[i].fireRatio = 2;
				this->enemy[i].fireMomentum = newPoint(0, 0, -5);
				this->enemy[i].maxdamage = 40; //tough, huh?
			}

			for (i=0; i<5; i++)
			{
				this->enemy[i+5] = *defaultShieldGen;
				this->enemy[i+5].location = newPoint(-40+i*20, -15, 1050);
				this->enemy[i+5].angle = newAngle(0, 0, 0);
				this->enemy[i+5].fireRatio = 2;
				this->enemy[i+5].maxdamage = 10;
				this->enemy[i+5].fireMomentum = newPoint(0, 0, -2);

				this->enemy[i+10] = *defaultShieldGen;
				this->enemy[i+10].location = newPoint(-40+i*20, -15, 1100);
				this->enemy[i+10].angle = newAngle(0, 0, 0);
				this->enemy[i+10].fireRatio = 2;
				this->enemy[i+10].maxdamage = 10;
				this->enemy[i+10].fireMomentum = newPoint(0, 0, -2);

			}

			break;

		case 3:
			this->numenemies = 5;
			this->length = 350;

			this->enemy[0] = *defaultGenerator;
			this->enemy[0].location = newPoint(0, -6, 1350);
			this->enemy[0].fireRatio = 2;

			this->enemy[1] = *defaultShieldGen;
			this->enemy[1].location = newPoint(-10, -15, 1380);
			this->enemy[1].fireRatio = 5;
			this->enemy[1].spin[0] = newAngle(0, 2, 0);
			this->enemy[1].maxdamage = 10;

			this->enemy[2] = *defaultShieldGen;
			this->enemy[2].location = newPoint( 10, -15, 1380);
			this->enemy[2].fireRatio = 5;
			this->enemy[2].spin[0] = newAngle(0, 2, 0);
			this->enemy[2].maxdamage = 10;

			this->enemy[3] = *defaultShieldGen;
			this->enemy[3].location = newPoint(-20, -15, 1320);
			this->enemy[3].fireRatio = 5;
			this->enemy[3].spin[0] = newAngle(0, 2, 0);
			this->enemy[3].maxdamage = 20;

			this->enemy[4] = *defaultShieldGen;
			this->enemy[4].location = newPoint( 20, -15, 1320);
			this->enemy[4].fireRatio = 5;
			this->enemy[4].spin[0] = newAngle(0, 2, 0);
			this->enemy[4].maxdamage = 20;
		break;
	}

}




void getGroupSetup_world0(Group *this, short group, Enemy *defaultGenerator, Enemy *defaultShieldGen, Enemy *defaultFighter)
{
	int i;

	switch(group) {
		case 0:
			this->numenemies = 8;
			this->length = 300;

			for (i=0; i<2; i++) {
				this->enemy[i*2] = *defaultShieldGen;
				this->enemy[i*2].location = newPoint(-40, -15, (i+1)*150);
				this->enemy[i*2].fireRatio = 20;

				this->enemy[i*2+1] = *defaultShieldGen;
				this->enemy[i*2+1].location = newPoint(40, -15, (i+1)*150);
				this->enemy[i*2+1].fireRatio = 20;
			}

			for (i=0; i<4; i++) {
				this->enemy[i+4] = *defaultFighter;
				this->enemy[i+4].location = newPoint(i*10, -15, 200+i*10);
				this->enemy[i+4].momentum[0] = newPoint(0, 0, -2);
			}
		break;

		case 1:
			this->numenemies = 12;
			this->length = 300;

			for (i=0; i<2; i++) {
				this->enemy[i*2] = *defaultShieldGen;
				this->enemy[i*2].location = newPoint(-40, -15, (i+1)*150 + 300);
				this->enemy[i*2].fireRatio = 20;
				this->enemy[i*2].fireMomentum = newPoint(1, 0, -2);

				this->enemy[i*2+1] = *defaultShieldGen;
				this->enemy[i*2+1].location = newPoint(40, -15, (i+1)*150 + 300);
				this->enemy[i*2+1].fireRatio = 20;
				this->enemy[i*2+1].fireMomentum = newPoint(-1, 0, -2);
			}

			this->enemy[4] = *defaultFighter;
			this->enemy[4].location = newPoint(-40, -15, 300);
			this->enemy[4].angle = newAngle(0, -22, 0);
			this->enemy[4].numintervals = 3;
			this->enemy[4].momentum[0] = newPoint(1, 0, 2);
			this->enemy[4].time_interval[0] = 60;
			this->enemy[4].momentum[1] = newPoint(1, 0, 2);
			this->enemy[4].spin[1] = newAngle(0, -8, 0);
			this->enemy[4].time_interval[1] = 76;
			this->enemy[4].momentum[2] = newPoint(-1, 0, -2);
			this->enemy[4].spin[2] = newAngle(0, 0, 0);
			this->enemy[4].time_interval[2] = 0;

			this->enemy[5] = *defaultFighter;
			this->enemy[5].location = newPoint(40, -15, 300);
			this->enemy[5].angle = newAngle(0, 22, 0);
			this->enemy[5].numintervals = 3;
			this->enemy[5].momentum[0] = newPoint(-1, 0, 2);
			this->enemy[5].time_interval[0] = 60;
			this->enemy[5].momentum[1] = newPoint(-1, 0, 2);
			this->enemy[5].spin[1] = newAngle(0, 8, 0);
			this->enemy[5].time_interval[1] = 76;
			this->enemy[5].momentum[2] = newPoint(1, 0, -2);
			this->enemy[5].spin[2] = newAngle(0, 0, 0);
			this->enemy[5].time_interval[2] = 0;

			for (i=0; i<3; i++) {
				this->enemy[i+6] = *defaultFighter;
				this->enemy[i+6].location = newPoint(-80, -15, 500+i*30);
				this->enemy[i+6].angle = newAngle(0, -86, 0);
				this->enemy[i+6].momentum[0] = newPoint(1, 0, -1);
				this->enemy[i+6].fireMomentum = newPoint(1, 0, -2);

				this->enemy[i+9] = *defaultFighter;
				this->enemy[i+9].location = newPoint(80, -15, 500+i*30-15);
				this->enemy[i+9].angle = newAngle(0, 86, 0);
				this->enemy[i+9].momentum[0] = newPoint(-1, 0, -1);
				this->enemy[i+9].fireMomentum = newPoint(-1, 0, -2);
			}

		break;

		case 2:

			this->numenemies = 20;
			this->length = 300;

			for (i=0; i<2; i++) {
				this->enemy[i*2] = *defaultShieldGen;
				this->enemy[i*2].location = newPoint(-40, -15, (i+1)*150 + 600);
				this->enemy[i*2].fireRatio = 20;
				this->enemy[i*2].fireMomentum = newPoint(1, 0, -2);

				this->enemy[i*2+1] = *defaultShieldGen;
				this->enemy[i*2+1].location = newPoint(40, -15, (i+1)*150 + 600);
				this->enemy[i*2+1].fireRatio = 20;
				this->enemy[i*2+1].fireMomentum = newPoint(-1, 0, -2);
			}

			for (i=0; i<3; i++) {
				this->enemy[i+4] = *defaultFighter;
				this->enemy[i+4].location = newPoint(-70, -15, 650+i*30);
				this->enemy[i+4].angle = newAngle(0, -64, 0);
				this->enemy[i+4].momentum[0] = newPoint(2, 0, -1);

				this->enemy[i+7] = *defaultFighter;
				this->enemy[i+7].location = newPoint(70, -15, 650+i*30-15);
				this->enemy[i+7].angle = newAngle(0, 64, 0);
				this->enemy[i+7].momentum[0] = newPoint(-2, 0, 0);
			}

			for (i=0; i<5; i++) {
				this->enemy[i+10] = *defaultFighter;
				this->enemy[i+10].location = newPoint(-40-i*15, -15, 800+i*15);
				this->enemy[i+10].angle = newAngle(0, -96, 0);
				this->enemy[i+10].momentum[0] = newPoint(1, 0, -1);

				this->enemy[i+15] = *defaultFighter;
				this->enemy[i+15].location = newPoint(40+i*15, -15, 850+i*15);
				this->enemy[i+15].angle = newAngle(0, 96, 0);
				this->enemy[i+15].momentum[0] = newPoint(-1, 0, -1);

			}

		break;

		case 3:
			this->numenemies = 5;
			this->length = 230;

			this->enemy[0] = *defaultGenerator;
			this->enemy[0].location = newPoint(0, -6, 1050);
			this->enemy[0].fireRatio = 2;

			this->enemy[1] = *defaultShieldGen;
			this->enemy[1].location = newPoint(-10, -15, 1080);
			this->enemy[1].fireRatio = 5;
			this->enemy[1].spin[0] = newAngle(0, 2, 0);
			this->enemy[1].maxdamage = 10;

			this->enemy[2] = *defaultShieldGen;
			this->enemy[2].location = newPoint( 10, -15, 1080);
			this->enemy[2].fireRatio = 5;
			this->enemy[2].spin[0] = newAngle(0, 2, 0);
			this->enemy[2].maxdamage = 10;

			this->enemy[3] = *defaultShieldGen;
			this->enemy[3].location = newPoint(-20, -15, 1020);
			this->enemy[3].fireRatio = 5;
			this->enemy[3].spin[0] = newAngle(0, 2, 0);
			this->enemy[3].maxdamage = 20;

			this->enemy[4] = *defaultShieldGen;
			this->enemy[4].location = newPoint( 20, -15, 1020);
			this->enemy[4].fireRatio = 5;
			this->enemy[4].spin[0] = newAngle(0, 2, 0);
			this->enemy[4].maxdamage = 20;

	}

}

void createWorld(World *this, short world)
{
	switch (world)
	{
		case 0:
			this->numgroups = 4;
		break;

		case 1:
			this->numgroups = 4;
		break;

		case 2:
			this->numgroups = 6;
		break;
	}

}

// Draw the group and move it
short doGroupStuff(Camera *camera, Group *group, Ship *ship, Weapon *defaultPulse, Weapon *defaultBarrier)
{
	int i, move=0;

	int collision = -1;

	if (OSTimerExpired(MISC_TIMER)) {
		move = 1;
		OSTimerRestart(MISC_TIMER);
	}

	for (i=0; i<group->numenemies; i++)
	{
		if (group->enemy[i].location.z - camera->center.z > 0
		&&  group->enemy[i].location.z - camera->center.z < 150
		&&  group->enemy[i].damage < group->enemy[i].maxdamage) {
			drawLines(camera, newPoint(group->enemy[i].location.x,
									   group->enemy[i].location.y,
									   group->enemy[i].location.z),
							  group->enemy[i].angle,
							  group->enemy[i].objlines,
							  group->enemy[i].numlines, 1);

			if (group->enemy[i].weapon.energy > 0) {
				doWeaponStuff(camera, &group->enemy[i].weapon, ship->location);
				if (hasShipBeenShot(ship, &group->enemy[i].weapon.location)) {
					group->enemy[i].weapon.energy = 0;
					ship->shield -= group->enemy[i].weapon.damage;
				}
			}
			else if (random(group->enemy[i].fireRatio) == 1) {
				if (group->enemy[i].type == BARRIER)
					group->enemy[i].weapon = *defaultBarrier;
				else
					group->enemy[i].weapon = *defaultPulse;

				group->enemy[i].weapon.location = group->enemy[i].location;

				if (group->enemy[i].type == GENERATOR || group->enemy[i].type == COPTER)
					group->enemy[i].weapon.type = HOMING;
				else {
					group->enemy[i].weapon.type = SINGLE;
					group->enemy[i].weapon.momentum = group->enemy[i].fireMomentum;
				}
			}

			if (move == 1) {
				moveEnemy(&group->enemy[i]);
			}

			if (hasShipCollided(ship, &group->enemy[i]))
				collision = i;
		}

	}



	return collision;
}

short hasShipCollided(Ship *this, Enemy *with)
{
	int this_x0 = this->location.x-8,
		this_y0 = this->location.y-2,
		this_z0 = this->location.z-5,
		this_x1 = this->location.x+8,
		this_y1 = this->location.y+2,
		this_z1 = this->location.z+5;

	int square_half = with->square/2;
	int with_x0 = with->location.x-square_half,
		with_y0 = with->location.y-2,
		with_z0 = with->location.z-square_half,
		with_x1 = with->location.x+square_half,
		with_y1 = with->location.y+2,
		with_z1 = with->location.z+square_half;

	return this_x0 < with_x1 && this_x1 > with_x0 && this_z0 < with_z1 && this_z1 > with_z0 && this_y0 < with_y1 && this_y1 > with_y0;

}

short hasShipBeenShot(Ship *this, Point *with)
{
	int this_x0 = this->location.x-8,
		this_z0 = this->location.z-5,
		this_x1 = this->location.x+8,
		this_z1 = this->location.z+5,
		this_y0 = this->location.y-2,
		this_y1 = this->location.y+2;


	return this_x0 < with->x && this_x1 > with->x && this_z0 < with->z && this_z1 > with->z && this_y0 < with->y && this_y1 > with->y;

}
